#ifndef __TVGUIDE_EPGGRID_H
#define __TVGUIDE_EPGGRID_H

#include <vdr/epg.h>
#include "config.h"
#include "gridelement.h"

// --- cEpgGrid  -------------------------------------------------------------

class cEpgGrid : public cGridElement {
private:
    const cTimer *timer;
    const cEvent *event;
    cTextWrapper *extText;
    cString timeString;
    void DrawText(void);
    void DrawIcon(cString iconText, tColor color);
    time_t Duration(void) { return event->Duration(); };
public:
    cEpgGrid(cChannelEpg *c, const cEvent *event);
    virtual ~cEpgGrid(void);
    void SetViewportHeight(void);
    void PositionPixmap(void);
    void SetText(void);
    const cEvent *GetEvent(void) { return event; };
    time_t StartTime(void) { return event->StartTime(); };
    time_t EndTime(void) { return event->EndTime(); };
    void SetTimer(void);
    void SetSwitchTimer(void);
    cString GetTimeString(void);
    void Debug();
};

#endif //__TVGUIDE_EPGGRID_H
